﻿;/////////////////////////////////////////////////////////////////////////////////
;minScript.
;==========
;
;Garbage Collector Extensions module.
;
;© Big Eared Software 2017.
;==========================
;/////////////////////////////////////////////////////////////////////////////////

;/////////////////////////////////////////////////////////////////////////////////
;NOTES.
;
;/////////////////////////////////////////////////////////////////////////////////


;-INTERNAL FUNCTIONS.


;-PUBLIC FUNCTIONS.

;/////////////////////////////////////////////////////////////////////////////////
Procedure minScript_AddGCExtension(addressOfFunction)
  Protected blnProceed = #True
  If addressOfFunction
    CompilerIf #PB_Compiler_Thread
      LockMutex(minScript_Globals\threadMutex)
    CompilerEndIf
    ;Make sure we don't already have the extension registered.
      ForEach minScript_Globals\ptrGCExtensions()
        If minScript_Globals\ptrGCExtensions() = addressOfFunction
          blnProceed = #False
          Break
        EndIf
      Next
    If blnProceed
      AddElement(minScript_Globals\ptrGCExtensions())
      minScript_Globals\ptrGCExtensions() = addressOfFunction
    EndIf
    CompilerIf #PB_Compiler_Thread
      UnlockMutex(minScript_Globals\threadMutex)
    CompilerEndIf
  EndIf
EndProcedure
;/////////////////////////////////////////////////////////////////////////////////




; IDE Options = PureBasic 5.60 (Windows - x64)
; ExecutableFormat = Shared dll
; CursorPosition = 36
; FirstLine = 14
; Folding = -
; EnableThread
; Executable = d.exe.dll.exe.dll
; EnableUnicode